//----------------------------------------------------------------------------------------------------------------------
//	G[^\tg
//----------------------------------------------------------------------------------------------------------------------

#include <avr\io.h>
#include <avr\interrupt.h>
#include <avr\sleep.h>
#include <avr\wdt.h>

#include "mega48io.h"

#include "FlatMot.h"

//----------------------------------------------------------------------------------------------------------------------


volatile short gProportionalGain = 1000;			//QC
volatile short gIntegralGain = 200;					//ϕQC


volatile USHORT gSystemTimer = 0;					//[ms]
volatile USHORT gSleepTime = 0;						//X[v^C}[ms]

volatile UCHAR gWidthFlag=1;						//pXtO
volatile USHORT gWidth=0xffff;						//pX

volatile ULONG gServoWidth=1500;					//T[{ʒu

volatile ULONG gName;								//ԊORJX^R[h
volatile USHORT gData;								//ԊORf[^

volatile UCHAR gEvent;								//Cxgobt@

volatile UCHAR gTxBuf[6];							//Mobt@

//----------------------------------------------------------------------------------------------------------------------
//	^C}ORyA`
//	荞(1ms)
//----------------------------------------------------------------------------------------------------------------------

ISR(TIMER0_COMPA_vect)
{
	static UCHAR speedTime=10;	//x[ms]

	gSystemTimer++;

	speedTime--;
	if(speedTime == 0)	//xH
	{
		speedTime=10;
		gEvent |= EVENT_SPEED;	//xCxg
	}
}

//----------------------------------------------------------------------------------------------------------------------
//	^C}PRyAa
//	T[{(20ms)
//----------------------------------------------------------------------------------------------------------------------

ISR(TIMER1_COMPB_vect)
{
	static USHORT width;

	if(B_TCCR1A.bit._COM1B == 3)	//RyA1óH
	{
		B_TCCR1A.bit._COM1B = 2;	//RyA0o͂ɐݒ
		width = gServoWidth;
		B_OCR1B.word = OCR1B+width;
	}
	else
	{
		B_TCCR1A.bit._COM1B = 3;	//RyA1o͂ɐݒ
		B_OCR1B.word = OCR1B+(20000-width);
	}
}

//----------------------------------------------------------------------------------------------------------------------
//	^C}PRyA`
//	pX͈͊O
//----------------------------------------------------------------------------------------------------------------------

ISR(TIMER1_COMPA_vect)
{
	B_OCR1A.word = OCR1A+0x8000;
	gWidthFlag=0;
	gWidth = 0xffff;
}

//----------------------------------------------------------------------------------------------------------------------
//	^C}PLv`
//	pX
//----------------------------------------------------------------------------------------------------------------------

ISR(TIMER1_CAPT_vect)
{
	static USHORT oldCap;
	USHORT cap;
	USHORT width;

	cap = B_ICR1.word;

	if(gWidthFlag==1)
	{
		width = cap - oldCap;		//pXvZ
		gWidth = width;
	}
	else
	{
		gWidthFlag=1;				//pXJnpXL
	}

	oldCap = cap;
	B_OCR1A.word  = cap+0x8000;

}

//----------------------------------------------------------------------------------------------------------------------
//	INT0
//	ԊORMp
//----------------------------------------------------------------------------------------------------------------------

ISR(INT0_vect)
{
	static char count = -1;
	static USHORT buf[2];
	static USHORT old = 0;
	USHORT now;
	static ULONG name;
	static USHORT data;

	now = B_TCNT1.word;

	if(B_EICRA.bit._ISC0 == 3)	//INT0GbW?
	{
		B_EICRA.bit._ISC0 = 2;	//INT0GbWɕύX
		buf[0] = now-old;
		old = now;
	}
	else
	{
		B_EICRA.bit._ISC0 = 3;	//INT0GbWɕύX
		buf[1] = now-old;
		old = now;

		if(buf[0] > 2500 && buf[0] < 5000 && buf[1] > 1200 && buf[1] < 2000)		//ON==3.2ms &&  OFF==1.6ms?
		{
			count = 0;
			name = 0;
			data = 0;

		}
		else if(count >= 0 && buf[0] < 600)	//ON==0.4ms?
		{
			if(buf[1] >= 800)	//OFF==1.2ms?
			{
				if(count < 32)
				{
					name <<= 1;
					name |=  1;
				}
				else if(count < 48)
				{
					data <<= 1;
					data |=  1;
				}
				count++;
			}
			else if(buf[1] < 800)		//OFF==0.4ms?
			{
				if(count < 32)
				{
					name <<= 1;
					name &=  0xfffffffe;
				}
				else if(count < 48)
				{
					data <<= 1;
					data &=  0xfffe;
				}
				count++;

			}
			else
			{
				count = -1;
			}

			if(count >= 48)
			{
				gName = name;
				gData = data;
				gEvent |= EVENT_RECEIVE;		//MCxg
				count = -1;
			}
		}
		else
		{
			count = -1;
		}
	}
}

//----------------------------------------------------------------------------------------------------------------------
//	USART0M
//----------------------------------------------------------------------------------------------------------------------

ISR(USART_TX_vect)
{
	static UCHAR cnt = 0;

	if(gTxBuf[cnt] != 0)
	{
		B_UDR0.byte  = gTxBuf[cnt];
		cnt++;
	}
	else
	{
		B_UCSR0B.bit._TXCIE = 0;		//M֎~
		cnt=0;
	}
}

//----------------------------------------------------------------------------------------------------------------------
//	^C}Oݒ
//----------------------------------------------------------------------------------------------------------------------

void Timer0Setup(void)
{
	B_OCR0A.byte = MPU_CLK/64/1000-1;	//1ms
	B_TCCR0A.bit._WGM001 = 2;			//CTC
	B_TCCR0B.bit._WGM02  = 0;			//
	B_TCCR0B.bit._CS0    = 3;			//1/64
	B_TIMSK0.bit._OCIE0A = 1;			//OCR0A
}

//----------------------------------------------------------------------------------------------------------------------
//	^C}Pݒ
//	CvbgLv`ݒ(GR[_pX)
//	AEgvbgRyAݒ(pX͈͊O̎̏)
//	AEgvbgRyAݒ(݁AVXe^C}[j
//----------------------------------------------------------------------------------------------------------------------

void Timer1Setup(void)
{
	B_TCCR1A.bit._WGM101 = 0;			//ʏ퓮
	B_TCCR1B.bit._WGM123 = 0;			//
	B_TCCR1A.bit._COM1A  = 0;			//o͂Ȃ
	B_TCCR1A.bit._COM1B  = 2;			//RyA0o
	B_TCCR1B.bit._CS1 = 2;				//1/8
	B_TCCR1B.bit._ICES1 = 1;			//Lv`GbW
	B_TCCR1B.bit._ICNC1 = 1;			//Lv`mCYLZ
	B_OCR1A.word  = 0x8000;				//͈͊O
	B_TIMSK1.bit._OCIE1A =1;			//RyA`荞݋
	B_TIMSK1.bit._OCIE1B =1;			//RyAa荞݋
	B_TIMSK1.bit._ICIE1 =1;				//Lv`荞݋

}

//----------------------------------------------------------------------------------------------------------------------
//	^C}Qݒ
//----------------------------------------------------------------------------------------------------------------------

void Timer2Setup(void)
{
	B_OCR2A.byte = 0;					//o0
	B_OCR2B.byte = 0;					//o0
	B_TCCR2A.bit._WGM201 = 1;			//ʑPWM
	B_TCCR2B.bit._WGM22  = 0;			//
	B_TCCR2A.bit._COM2A  = 2;			//HANeBuPWM
	B_TCCR2A.bit._COM2B  = 2;			//HANeBuPWM
	B_TCCR2B.bit._CS2    = 1;			//1/1
}

//----------------------------------------------------------------------------------------------------------------------
//	INT0ݒ
//----------------------------------------------------------------------------------------------------------------------

void Int0Setup(void)
{
	B_EICRA.bit._ISC0 = 2;				//INT0GbW
	B_EIMSK.bit._INT0 = 1;				//INT0
}

//----------------------------------------------------------------------------------------------------------------------
//	UART0ݒ
//----------------------------------------------------------------------------------------------------------------------
void Uart0Setup(void)
{
	B_UCSR0B.bit._TXEN = 1;								//M
	B_UBRR0.word = (MPU_CLK*10/16/UART0_SPEED+5)/10-1;	//{[[g
}

//----------------------------------------------------------------------------------------------------------------------
//	Ԓ[ms]
//----------------------------------------------------------------------------------------------------------------------

void msSleep(USHORT time)
{
	gSleepTime = time;
	while(gSleepTime != 0)
	{
		//sleep_mode();
		wdt_reset();
	}
}

//----------------------------------------------------------------------------------------------------------------------
//	𕶎(5Œ)ɕϊ
//----------------------------------------------------------------------------------------------------------------------

void UshortToStr(USHORT data, UCHAR *str)
{
	str[0] = data/10000+'0';
	data = data%10000;
	str[1] = data/1000+'0';
	data = data%1000;
	str[2] = data/100+'0';
	data = data%100;
	str[3] = data/10+'0';
	data = data%10;
	str[4] = data+'0';
	str[5] = 0;
}

//----------------------------------------------------------------------------------------------------------------------
//	16i(4Œ)ɕϊ
//----------------------------------------------------------------------------------------------------------------------

void UshortToHex(USHORT data, UCHAR *str)
{
	UCHAR n;

	for(n=0;n < 4;n++)
	{
		str[3-n] = (data & 0x000f);
		if(str[3-n] <= 9)
		{
			str[3-n] += '0';
		}
		else
		{
			str[3-n] += 'a' - 10;
		}

		data >>=4;
	}

	str[4] = 0;
}
//----------------------------------------------------------------------------------------------------------------------
//	x
//----------------------------------------------------------------------------------------------------------------------

void SpeedLoop(short setSpeed)
{
	static short speed;
	long difference;
	long proportional;
	static long integral = 0;
	long out;
	UCHAR str[7];

	//pXx(xtB[hobNM)ϊ
	if(gWidth < 0x7fff)
	{
		speed = CONVERT_BASE/gWidth;	//pXȂƂxvZ
	}
	else
	{
		speed = 0;						//pXs\ȂƂx0
	}

	B_OCR2A.byte = speed >> 6;

	//΍vZ
	//΍=xw-xtB[hobNM
	if(setSpeed >= 0)
	{
		difference = setSpeed-speed;	//]̂Ƃ
	}
	else
	{
		difference = -setSpeed-speed;	//t]̂Ƃ
	}

	//QCZ
	proportional = difference * gProportionalGain;
	if(proportional > 0x000fffff)
	{
		proportional = 0x000fffff;
	}
	else if(proportional < -0x000fffff)
	{
		proportional = 0;
	}

	//ϕQCZ
	integral = integral + difference * gIntegralGain;
	if(integral > 0x000fffff)
	{
		integral = 0x000fffff;
	}
	else if(integral < 0)
	{
		integral = 0;
	}

	//o͉Z
	out = proportional+integral;
	if(out > 0x000fffff)
	{
		out = 0x000fffff;
	}
	else if(out < 0)
	{
		out = 0;
	}

	//[^[^hColo
	out = out >> 12;
	B_OCR2B.byte = out;
	if(setSpeed >= 0)
	{
		B_PORTD.bit.b7 = 0;				//]ݒ
	}
	else
	{
		B_PORTD.bit.b7 = 1;				//t]ݒ
	}

	#if SPEED_UART0_OUT == true
		UshortToStr(speed, str);

		B_UDR0.byte = str[0];
		gTxBuf[0] = str[1];
		gTxBuf[1] = str[2];
		gTxBuf[2] = str[3];
		gTxBuf[3] = str[4];
		gTxBuf[4] = '\r';
		gTxBuf[5] = 0;
		B_UCSR0B.bit._TXCIE = 1;		//M

	#endif
}

//----------------------------------------------------------------------------------------------------------------------
//	C
//----------------------------------------------------------------------------------------------------------------------

int main(void)
{
	short setSpeed=0;
	USHORT data;
	UCHAR str[5];

	B_PORTB.byte = 0xf3;
	B_DDRB.byte  = 0x0c;

	B_PORTC.byte = 0xff;
	B_DDRC.byte  = 0x00;

	B_PORTD.byte = 0x77;
	B_DDRD.byte  = 0x8a;

//	wdt_enable(WDTO_30MS);

	Timer0Setup();
	Timer1Setup();
	Timer2Setup();

	Int0Setup();

	Uart0Setup();

	sei();	//

	while(true)
	{
		wdt_reset();
		//sleep_mode();

		if(gEvent & EVENT_RECEIVE)	//MCxg?
		{
			cli();
			gEvent &= ~EVENT_RECEIVE;
			data = gData;
			sei();
			switch(data)
			{
				case 0x724c:				//1{^(x1000)
					setSpeed = 1000;
					break;

				case 0xf244:				//2{^(x2000)
					setSpeed = 2000;
					break;

				case 0x0a43:				//3{^(x3000)
					setSpeed = 3000;
					break;

				case 0x8a4b:				//4{^(x4000)
					setSpeed = 4000;
					break;

				case 0x4a47:				//5{^(x5000)
					setSpeed = 5000;
					break;

				case 0x4a4f:				//6{^(x6000)
					setSpeed = 6000;
					break;

				case 0x2a41:				//7{^(x7000)
					setSpeed = 7000;
					break;

				case 0xaa49:				//8{^(x8000)
					setSpeed = 8000;
					break;

				case 0x6a45:				//9{^(x9000)
					setSpeed = 9000;
					break;

				case 0xea4d:				//10{^(x10000)
					setSpeed = 10000;
					break;

				case 0x1a42:				//11{^(x11000)
					setSpeed = 11000;
					break;

				case 0x9a4a:				//12{^(x12000)
					setSpeed = 12000;
					break;

				case 0xc881:				//͐ؑփ{^(x25000)
					setSpeed = 25000;
					break;

				case 0xea81:				//{^(xUP)
					if(setSpeed < 15000)
					{
						setSpeed += 50;
					}
					break;

				case 0x0481:				//{^(xDOWN)
					if(setSpeed > -15000)
					{
						setSpeed -= 50;
					}
					break;

				case 0x4a8b:				//{^(~AT[{_)
					setSpeed = 0;
					gServoWidth = 1500;
					break;

				case 0xeb80:				//{^(T[{])
					if(gServoWidth < 2000)
					{
						gServoWidth += 100;
					}
					break;

				case 0x1b8f:				//{^(T[{E])
					if(gServoWidth > 1000)
					{
						gServoWidth -= 100;
					}
					break;
			}

			#if IR_CODE_OUT
				UshortToHex(data, str);
				B_UDR0.byte = str[0];
				gTxBuf[0] = str[1];
				gTxBuf[1] = str[2];
				gTxBuf[2] = str[3];
				gTxBuf[3] = '\r';
				gTxBuf[4] = 0;
				B_UCSR0B.bit._TXCIE = 1;		//M

			#endif
		}
		if(gEvent & EVENT_SPEED)			//xCxg?
		{
			cli();
			gEvent &= ~EVENT_SPEED;
			sei();

			SpeedLoop(setSpeed);
		}
	}



}

//----------------------------------------------------------------------------------------------------------------------
